 #include <QTRSensors.h>
#include <DRV8835MotorShield.h>
#define KP 0.090  // kp = 0.30  0.15  2.35   5.35       2
#define KD 2 //kd .6        2.2    9.50    18         35
#define M1_MAX_SPEED 550
#define M2_MAX_SPEED 550
#define M1_DEFAULT_SPEED 450
#define M2_DEFAULT_SPEED 450
//#define MIDDLE_SENSOR 3, 4 
#define NUM_SENSORS  6     //  
#define TIMEOUT 2500
#define EMITTER_PIN 2      //    
#define DEBUG 1 //      
DRV8835MotorShield motors;
QTRSensorsRC qtrrc((unsigned char[]) {20, 19, 18, 17, 16, 15} ,NUM_SENSORS, TIMEOUT, EMITTER_PIN); //    
unsigned int sensorValues[NUM_SENSORS];

//motors.flipM1(true);
//motors.flipM2(true)   
void setup()
{
  
  manual_calibration(); 
}
int lastError = 0;
int  last_proportional = 0;
int integral = 0;
void loop()
{
  unsigned int sensors[6];
  int position = qtrrc.readLine(sensors);
  int error = position - 2500;
  int motorSpeed = KP * error + KD * (error - lastError);//   
  lastError = error;
  int rightMotorSpeed = M2_DEFAULT_SPEED + motorSpeed; //        
  int leftMotorSpeed = M1_DEFAULT_SPEED - motorSpeed;
    if (rightMotorSpeed > M1_MAX_SPEED ) rightMotorSpeed = M1_MAX_SPEED; //  
  if (leftMotorSpeed > M2_MAX_SPEED ) leftMotorSpeed = M2_MAX_SPEED; //  
  if (rightMotorSpeed < 0) rightMotorSpeed = 0; //      
  if (leftMotorSpeed < 0) leftMotorSpeed = 0; //      
   {
motors.setM1Speed(rightMotorSpeed); //    ,      "DRV8835MotorShield motors;"
motors.setM2Speed(leftMotorSpeed);

}
}
void manual_calibration() {
  int i;
  for (i = 0; i < 250; i++)  // 
  {
    qtrrc.calibrate(QTR_EMITTERS_ON);
    delay(20);
  }
  if (DEBUG) { //       
    Serial.begin(9600);
    for (int i = 0; i < NUM_SENSORS; i++)
    {
      Serial.print(qtrrc.calibratedMinimumOn[i]);
      Serial.print(' ');
    }
    Serial.println();
    for (int i = 0; i < NUM_SENSORS; i++)
{
  Serial.print(qtrrc.calibratedMaximumOn[i]);
  Serial.print(' ');
}

  }
}